#include <stdio.h>
#include <stdlib.h>
#include "gga.h"

/* well they needed to be defined somewhere */
struct waveform_rec *wavs = NULL;
struct track_rec *tracks = NULL;

int
main(int argc,char **argv)
{
	if (cmd_init()) {
		fprintf(stderr,"failed to initialize command input thread\n");
		return -1;
	}
	if (snd_init()) {
		fprintf(stderr,"failed to initialize sound output module\n");
		return -1;
	}
	if (x_init(argc,argv)) {
		fprintf(stderr,"failed to initialize x connection\n");
		return -1;
	}
	if (dispwav_init()) {
		fprintf(stderr,"failed to initialize waveform display window\n");
		return -1;
	}
	if (disptrack_init()) {
		fprintf(stderr,"failed to initialize tracker display window\n");
		return -1;
	}
	if (control_init()) {
		fprintf(stderr,"failed to initialize control module\n");
	}

	return control_loop();
}

void
do_cleanup(void)
{
	/* XXX */
	/* control_cleanup(); */
	/* disptrack_cleanup(); */
	/* dispwav_cleanup(); */
	/* x_cleanup(); */
	/* snd_cleanup(); */
	cmd_cleanup();
	exit(0);
}
